'' **************************************************
'' ** PROJECT 50: DIGITAL CLOCK                    **
'' ** FROM: 101 COOL PROJECTS FOR THE PPDB         **
'' ** BY JEFF LEDGER                               **
'' **************************************************
'' JUMPER THE FOLLOWING CONNECTIONS TOGETHER
''  P0  = SEGMENTS F
''  P1  = SEGMENTS E
''  P2  = SEGMENTS D1 & D2
''  P3  = SEGMENTS C
''  P4  = SEGMENTS B
''  P5  = SEGMENTS A1 & A2
''  P6  = SEGMENTS G1 & G2

''  P7  = R. DIG 3
''  P8  = L. DIG 3
''  P9  = R. DIG 2
''  P10 = L. DIG 2
''  P11 = R. DIG 1
''  P12 = L. DIG 1 

''  P29 = SCLK (DS1302 RTC)
''  P28 = IO   (DS1302 RTC)
''  P27 = CE   (DS1302 RTC)

''              --   <-- P5 (A1 & A2)
''  (F) P0 --> |  |  <-- P4 (B)
''              --   <-- P6 (G1 & G2)
''  (E) P1 --> |  |  <-- P3 (C)
''              --   <-- P2 (D1 & D2)
''
CON
  _clkmode = xtal1 + pll16x 
  _xinfreq = 5_000_000

 SCLK = 29
 IO   = 28
 CE   = 27
 
OBJ

  SN    : "Simple_Numbers"
  rtc   : "DS1302"

VAR

  byte hour, minute, second
 
PUB main | h,m,s,num,x,y,xx,xxx,yy,yyy
  dira[0..6]~~ ' SET SEGMENTS TO OUTPUT   
  dira[7..12]~
  
   
  ' to call each time the propeller start 
  rtc.init( SCLK, IO, CE )                         ' ports Clock, io, chip enable

  ' to call only after the DS1302 power on 
  rtc.config                                  ' Set configuration register

  ' to call all time you want to set time
  rtc.setDatetime( 09, 04, 08, 3, 5, 59, 50 )    '  month, day, year, day of week, hour, minute, seconde
                                                        
  repeat
     
     rtc.readTime( @hour, @minute, @second ) ' read time from DS1302 
    
     x := byte[(SN.decx(second,2))]                               
     y := byte[(SN.decx(second,2))+1]
     x -= "0"
     y -= "0"

     xx := byte[(SN.decx(minute,2))]
     yy := byte[(SN.decx(minute,2))+1]
     xx -= "0"
     yy -= "0"

     xxx := byte[(SN.decx(hour,2))]
     yyy := byte[(SN.decx(hour,2))+1]
     xxx -= "0"
     yyy -= "0"
    
    DIGIT(x,1) ''DIGIT (NUMBER,SEGMENT)
    waitcnt(100_000 + cnt)
        
    DIGIT(y,2)
    waitcnt(100_000 + cnt) 
     
    DIGIT(xx,3) ''DIGIT (NUMBER,SEGMENT)
    waitcnt(100_000 + cnt)
        
    DIGIT(yy,4)
    waitcnt(100_000 + cnt)

    DIGIT(xxx,5) ''DIGIT (NUMBER,SEGMENT)
    waitcnt(100_000 + cnt)
        
    DIGIT(yyy,6)
    waitcnt(100_000 + cnt)         
    DIRA[7..12] := %000000     
         
PUB DIGIT(NUM,SEG)
    

  if seg==1
     DIRA[7..12] := %010000
  if seg==2
     DIRA[7..12] := %100000
  if seg==3
     DIRA[7..12] := %000100
  if seg==4
     DIRA[7..12] := %001000
  if seg==5
     DIRA[7..12] := %000001
  if seg==6
     DIRA[7..12] := %000010     
     
  OUTA[0..6]:=%1111111
  
  if num==1
     DIRA[0..6] := %0001100
 
  if num==2
     DIRA[0..6] := %0110111

  if num==3
     DIRA[0..6] := %0011111

  if num==4
     DIRA[0..6] := %1001101

  if num==5
     DIRA[0..6] := %1011011

  if num==6
     DIRA[0..6] := %1111011

  if num==7
     DIRA[0..6] := %0001110

  if num==8
     DIRA[0..6] := %1111111

  if num==9
     DIRA[0..6] := %1011111

  if num==0
     DIRA[0..6] := %1111110


     